#include "stringfun.hh"

const std::string LTrim(const std::string& s)
{
    std::string::size_type q = 0;
    while(q < s.size() && (s[s.size()-q-1] == ' ' || s[s.size()-q-1] == '\t')) ++q;
    return std::string(s.data()+s.size()-q, s.size()-q);
}

const std::string RTrim(const std::string& s)
{
    std::string::size_type p = 0;
    while(p < s.size() && (s[p] == ' ' || s[p] == '\t')) ++p;
    return std::string(s.data()+p, s.size()-p);
}

const std::string Trim(const std::string& s)
{
    std::string::size_type p = 0;
    while(p < s.size() && (s[p] == ' ' || s[p] == '\t')) ++p;

    std::string::size_type q = 0;
    while((p+q) < s.size() && (s[s.size()-q-1] == ' ' || s[s.size()-q-1] == '\t')) ++q;

    return std::string(s.data()+p, s.size()-p-q);
}
